;-------------------------------------------;
;     TENTO PROGRAM  DEMONSTRUJE FUNKCI     ;
; OPTOPRIJIMACE A ZAZNAM KODU DO RAM PAMETI ;
;  - spustte si PC aplikaci, ktera prijima  ;
;       data pomoci serioveho portu!!       ;
;-------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'


	#include	displej.inc
	#include	unibuff.inc
	#include	ir_rec.inc

;---------------------------------------------
; KONSTANTY PROGRAMU

MINPULZ	EQU	D'150'	; maximalni delka jednoznacne poruchy

BLOK1	EQU	H'110'	; adresa zaznamu v RAM pameti (prvni byty)
BLOK2	EQU	H'190'	; adresa zaznamu v RAM pameti (druhe byty)
BUFF_SIZE	EQU	D'64'	; velikost prijimaciho IR-bufferu

MINKOD	EQU	D'6'	; minimalni pripustna delka kodu
MAXKOD	EQU	D'64'	; maximalni pripustna delka kodu

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TML:1
	TMH:1
	DDATA:1
	BUFF_IN:1	; pro obsluhu bufferu
	BUFF_OUT:1
	BUFF_STAT:1
	BUFF_TEMP:1
	BUFF_ADR:BUFF_SIZE
	POZICE:1
	KOD:2
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

;------------------------------------------------------
; RESET / START
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

;------------------------------------------------------
; OBSLUHA PRERUSENI

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	banksel	0
	BTFSS	PIR1,TMR1IF	; pokud doslo k preteceni casovace
	GOTO	RB_INT
	MOVLW	D'0'	; ulozime do bufferu nulovou hodnotu (16 bitu)
	CALL	IN_BUFF
	MOVLW	D'0'
	CALL	IN_BUFF
	banksel	PIE1	; nasledne zakazeme dalsi preruseni od casovace
	BCF	PIE1,TMR1IE
	banksel	0
RB_INT	BTFSS	INTCON,RBIF	; testujeme preruseni od optoprijimace
	GOTO	INT_END
	MOVF	PORTB,F		; "refresujeme" porovnavaci registr
	BCF	INTCON,RBIF	; vynulujeme priznak
	BCF	T1CON,TMR1ON	; zastavime TMR1
	banksel	PIE1
	BSF	PIE1,TMR1IE	; povolime prerusemi od casovace
	banksel	PIR1
	BTFSS	PIR1,TMR1IF	; pokud TMR1 pretekl,...
	GOTO	VYSLI_H
	CLRF	TMR1H		; ..., potom jej vynulujeme
	CLRF	TMR1L
	BCF	PIR1,TMR1IF
VYSLI_H	MOVF	TMR1H,W		; vyssi byte TMR1 vlozime do bufferu
	CALL	IN_BUFF
	MOVF	TMR1H,F		; pokud je vyssi byte nulovy,...
	BTFSS	STATUS,Z
	GOTO	SKOK
	MOVF	TMR1L,W		; ...potom testujeme zda je nulova
	BTFSC	STATUS,Z
	GOTO	SKOK
	SUBLW	MINPULZ		; pokud neni nulova,...
	BTFSS	STATUS,C		; ...testujeme, zda neni prilis mala
	GOTO	SKOK
	CLRF	TMR1L		; pokud je nenulova, ale mala,...
	BSF	PIR1,TMR1IF	; ...potom predstirame chybu v budoucim mereni
SKOK	MOVF	TMR1L,W		; zde vkladame nizsi byte TMR1 do bufferu
	CALL	IN_BUFF
	CLRF	TMR1H		; nulujeme TMR1
	CLRF	TMR1L
	BSF	T1CON,TMR1ON	; TMR1 je spusten

INT_END	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

;-------------------------------------------------
; INICIALIZACE
	
START	
	banksel	TRISB
	BCF	TRISB,4	; musi byt nastaveno jako vystup
	BCF	TRISB,5
	BCF	TRISB,6
	BSF	TRISB,7	; sem je pripojen optoprijimac
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	; inicializace bufferu
	BUFFINI 	BUFF_IN, BUFF_OUT,BUFF_STAT

	banksel	T1CON	; nastaveni TMR1 (predelicka 1:4);
	MOVLW	B'00101101'
	MOVWF	T1CON

	; inicializace displeje
	CALL	INITDISP
	; napis: "IR-prijimac"
	MOVLW	D'2'
	CALL	SETPOS
	MOVLW	'I'
	CALL	PUTZNAK
	MOVLW	'R'
	CALL	PUTZNAK
	MOVLW	'-'
	CALL	PUTZNAK
	MOVLW	'p'
	CALL	PUTZNAK
	MOVLW	'r'
	CALL	PUTZNAK
	MOVLW	'i'
	CALL	PUTZNAK
	MOVLW	'j'
	CALL	PUTZNAK
	MOVLW	'i'
	CALL	PUTZNAK
	MOVLW	'm'
	CALL	PUTZNAK
	MOVLW	'a'
	CALL	PUTZNAK
	MOVLW	'c'
	CALL	PUTZNAK

	BSF	INTCON,RBIE	; povoleno preruseni od optoprijimace
	BSF	INTCON,PEIE	; povoleno preruseni od nektere periferie (v tomto pripade TMR1)
	BSF	INTCON,GIE	; aktivace systemu preruseni

;----------------------------------------------------
; HLAVNI PROGRAM

	CLRF	POZICE	; ukazatele do zaznamu je nastaven na prvni polozku
LOOP	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud je v bufferu hodnota,...
	GOTO	LOOP
	CALL	OUT_BUFF	; ...ulozime ji do promenne KOD
	MOVWF	KOD+1
	CALL	OUT_BUFF
	MOVWF	KOD
	CALL	IR_REC	; volame zaznamenavaci podprogram
	BTFSS	STATUS,C	; je zaznam hotov?
	GOTO	LOOP	; - pokud ne, opakujeme cyklus
	CLRF	POZICE	; - pokud ano, cyklus konci a zahajime cteni zaznamu nastavenim ukazatele na prvni polozku
READING	CALL	READ_REC	; precteme polozku
	MOVF	KOD,F	; testujeme, zda to neni nula...
	BTFSS	STATUS,Z
	GOTO	NENULA
	MOVF	KOD+1,F
	BTFSC	STATUS,Z
	GOTO	$	; - pokud je to nula, potom program spadne do nekonecne prazdne smycky
NENULA	MOVLW	D'133'	; - pokud to nula neni, potom hodnotu vysleme na sriovy port
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KOD+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	READING	; pokracujeme ve cteni...

;------------------------------------------------------
; PROGRAMOVE MODULY

	; ukladani do bufferu
IN_BUFF	INBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 0
	RETURN
	
	; cteni z bufferu (s docasnou deaktivaci preruseni)
OUT_BUFF	OUTBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 1
	RETURN

	; zaznam do RAM pameti
IR_REC	IR_REC_	KOD, POZICE, BLOK1, BLOK2, MINKOD, MAXKOD
	RETURN

	; cteni z RAM pameti
READ_REC	READ_REC_	KOD, POZICE, BLOK1, BLOK2
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	END
